package com.gct.tools.etlcamelhuge.MQ;

import com.alibaba.fastjson.JSONObject;
import lombok.AllArgsConstructor;
import lombok.Data;

/**
 * class name: MQDiagnoseMsg
 * <p>
 * rocketMQ exchange message entity:
 * for diagnose process
 * <p>
 * Notice:
 * 1.the message key:well_id
 * 2.the formatter of sgt eg:0,123,1,253...
 * 3.use the secret "DiagnoseMsg_v1.0" to send message
 * 4.in order to send message sequence orderly,please do that :
 * sendOneWayOrderly(./././)
 * </p>
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/6/24 下午6:48
 */
@Data
@AllArgsConstructor
public class WarnMsg implements MessageBody {
    private String wellId;
    private String context;
    private String wnDate;
    private String resultId;
    private String category;
    private String rank;

    @Override
    public String toJsonBody() {
        return JSONObject.toJSONString(this);
    }
}
