package com.gct.tools.etlcamelhuge.camelconfig;

import org.springframework.boot.autoconfigure.jdbc.DataSourceProperties;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.boot.jdbc.DataSourceBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.sql.DataSource;

/**
 * class name: MyDataSourceConfiguration
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/4/21 下午1:42
 */
@Configuration
public class MyDataSourceConfiguration {

    @Bean(name = "centralbase")
    @ConfigurationProperties(prefix = "spring.datasource.ds1")
    public DataSource dataSource1() {
        return DataSourceBuilder.create().build();
    }

    @Bean(name = "oracle")
    @ConfigurationProperties(prefix = "spring.datasource.ds2")
    public DataSource dataSource3() {
        return DataSourceBuilder.create().build();
    }

    @Bean(name = "gtsj")
    @ConfigurationProperties(prefix = "spring.datasource.ds3")
    public DataSource dataSource4() {
        return DataSourceBuilder.create().build();
    }
}
