package com.gct.tools.etlcamelhuge.routeconfig;

import com.alibaba.fastjson.JSONObject;
import com.gct.tools.etlcamelhuge.MQ.MessageProducer;
import com.gct.tools.etlcamelhuge.entity.DiagnoseMsg;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.component.file.GenericFile;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.annotation.Resource;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;


/**
 * class name: CamelFileConfiguration
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/4/14 下午3:07
 */
@Configuration
public class CamelFileConfiguration {

    @Resource(name = "diagnoseMessageProducer")
    private MessageProducer producer;

    @Bean
    RouteBuilder routeBuilderFile() {
        return new RouteBuilder() {
            private Object apply(GenericFile genericFile) {
                File actualFile = (File) genericFile.getFile();
                try {
                    BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(actualFile)));
                    while (true) {
                        String body = in.readLine();
                        if (body == null || body.equals("")) break;
                        DiagnoseMsg diagnoseMsg = JSONObject.parseObject(body, DiagnoseMsg.class);
                        producer.send(diagnoseMsg);
                    }
                } catch (Exception ignored) {
                }
                return new Object();
            }

            @Override
            public void configure() {
                from("file:{{user.home}}/logs/etl/dgns-msg/")
                        .routeId("file-to-MQ").transform(
                        ).body(GenericFile.class, this::apply)
                        .end();
            }
        };
    }

}
